import java.util.Comparator;

public final class PLZKomparator implements Comparator<Person> {
    /* Klasse sollte final deklariert sein, damit verhindert wird, dass 
     * unbemerkt in einer Unterklasse eine andere Ordnung definiert wird.
     */

    public int compare(Person p1, Person p2) {
        int rc;

	if ( (rc=p1.gibPLZ()-p2.gibPLZ()) != 0) {
	    return rc;
	}
	else if ( (p1.gibStrasse().compareTo(p2.gibStrasse())) != 0) {
	    return rc;
	}
	else if ( (rc=p1.gibHausNummer()-p2.gibHausNummer()) != 0) {
	    return rc;
	}
	else if ( (rc=p1.gibName().compareTo(p2.gibName())) != 0) {
	    return rc;
	}
	else  {
	    return p1.gibVorname().compareTo(p2.gibVorname());
	}
    }

    /* Ein Ueberschreiben der Methode equals() ist nicht notwendig,
     * da equals() von Object geerbt wird und dort die geforderte Semantik hat.
     * Man beachte hierzu die Dokumentation von Comparator<T>.
     */
}
